/*
 *         Stephen Potter <stephenp@aiai.ed.ac.uk>
 * Copyright: (c) 2001-2, AIAI, University of Edinburgh
 */

//package ix.jabber;

import java.io.*;
import java.lang.*;

import org.jdom.Text;
import org.jdom.Element;
import org.jdom.Document;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

import org.apache.xerces.parsers.*;

//import org.w3c.dom.*;
//import com.sun.xml.tree.*;
//import sunlabs.brazil.util.http.*;
import java.util.*;
import java.net.*;

import org.jabber.jabberbeans.*;
import org.jabber.jabberbeans.Extension.*;
import org.jabber.jabberbeans.serverside.*;
import org.jabber.jabberbeans.util.*;


/*
 * A class that encapsulates the knowledge needed for
 * sending and receiving messages using the Jabber protocol.
 */

public class ixmifflin {

    public static ConnectionBean connectionBean;
    public static String jabberServer="akt.aiai.ed.ac.uk";
    public static String username="ix-mifflin";
    public static String password="jabber";
    public static String presence="Online";
    //    public static String mifflinServer="mifflin-user@akt.aiai.ed.ac.uk";
    public static String mifflinServer;
    //public static String mifflinID="13710824220";
    public static String mifflinID;
    //    public IPC.MessageListener ipcListener = null;

    //public JabberCommunicationStrategy() {
    //}

    /**
     * Sends a string to a named I-X panel.
     */
    public static void sendText(String contents) {

   
	MessageBuilder mb=new MessageBuilder();
	Message msg;
	//set destination user.

	// assume that toName is of the form username@jabberserver...

	int atInd = mifflinServer.lastIndexOf("@");
	
        String name = mifflinServer.substring(0,atInd);
	String server = mifflinServer.substring(atInd+1);

        System.out.println("\nSending to:"+name+" at: "+server);

	// note session information here...
	mb.setToAddress(new JID(name, server, mifflinID));
	
	mb.setBody(contents);
	try
	    {
		msg=(Message)mb.build();
	    }
	catch (InstantiationException e)
	    {
		//build failed ?
		System.out.println("error creating message packet:");
		System.out.println(e.toString());
		return;
	    }

	//send message
	connectionBean.send(msg);
    }


    // logon to the named jabber server...
    public static void logon(){
	
	InfoQueryBuilder iqb=new InfoQueryBuilder();
	InfoQuery iq;
	//and the auth data builder
	IQAuthExtensionBuilder iqAuthb=new IQAuthExtensionBuilder();

	//we are setting info
	iqb.setType("set");

	//user and password are from the commandline, resource will be jtest.
	iqAuthb.setUsername(username);
	iqAuthb.setPassword(password);
	iqAuthb.setResource("ix-mifflin_gateway");

	//build the Auth data
	try
	{
	    iqb.addExtension(iqAuthb.build());
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on Auth object build:");
	    java.lang.System.out.println(e.toString());
	    return;
	}

	//build the iq packet
	try
	{
	    //build the full InfoQuery packet
	    iq=(InfoQuery)iqb.build();
	}
	catch (InstantiationException e)
	{
	    //building failed ?
	    java.lang.System.out.println("Fatal Error on IQ object build:");
	    java.lang.System.out.println(e.toString());
	    return ;
	}


	//send the InfoQuery packet to the server to log in
	connectionBean.send(iq);
	
	java.lang.System.out.println("Send requested for IQ");
	
    }


    /**
     * Initiate a jabber receiver object and set up for receiving messages.
     */
    public static void setupServer() {

	InetAddress host;
	connectionBean = new ConnectionBean();
	//ipcListener = listener;

	try{
	    connectionBean.addPacketListener(new MyPacketListener());
	    connectionBean.addConnectionListener(new MyConnectionListener());

	    host = InetAddress.getByName(jabberServer);
	    System.out.print("got host\n");
	    connectionBean.connect(host);
	    System.out.print("connected!\n");	    
	    logon();
	}
	catch (Exception e){
	    System.out.print(e);
	}

	PresenceBuilder pb=new PresenceBuilder();
	    
	//this is presence to the irc transport on jabber.org. This will log
	//you into the #jabber channel. The best way to see this working is to
	//be on the jabber channel yourself (it is on irc.openprojects.net)
	//	JID dest=new JID("#jabberbeans","irc.jabber.org",
	//		"jtest");
	//pb.setToAddress(dest);
 
	presence = "Online"; // default

	String show = "";

	if(presence.equalsIgnoreCase("Away") || 
	   presence.equalsIgnoreCase("Lunch") ||
	   presence.equalsIgnoreCase("Bank"))
	    show = "away";
	if(presence.equalsIgnoreCase("Busy") || 
	   presence.equalsIgnoreCase("Working") ||
	   presence.equalsIgnoreCase("Mad"))
	    show = "dnd";
	if(presence.equalsIgnoreCase("Extended Away") || 
	   presence.equalsIgnoreCase("Gone Home") ||
	   presence.equalsIgnoreCase("Gone to Work") ||
	   presence.equalsIgnoreCase("Sleeping"))
	    show = "xa";
	if(presence.equalsIgnoreCase("Wants to Chat"))
	    show = "chat";

	pb.setStatus(presence);
	pb.setStateShow(show);

	try
	    {
		//build and send presence
		connectionBean.send(pb.build());
	    }
	catch (InstantiationException e)
	    {
		//building failed ?
		System.out.println
		    ("Fatal Error on Presence object build:");
		System.out.println(e.toString());
		return ;
	    }
    
    }


    static class MyConnectionListener implements ConnectionListener
    {
	public void connected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connected!");
	}
	public void disconnected(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Disconnected");
	}
	public void connecting(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connecting...");
	    }
	public void connectFailed(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connect Failed");
	}
	public void connectionChanged(ConnectionEvent ce)
	{
	    System.out.println("CLDebug: Connection Changed");
	}
    }


    static class MyPacketListener implements PacketListener {

	public void receivedPacket(PacketEvent pe)
	{
	    Packet p = pe.getPacket();

	    System.out.println("PLDebug: RECEIVED PACKET!!! : " 
			       + p.toString());

	    if(p instanceof Message){

		try{
		    Message m = (Message)p;
	
		    // normal, chat, or headline
		    System.out.println("Message of type: " + m.getType());
		    System.out.println("\treceived from: " + 
				       m.getFromAddress().toString());
		    System.out.println("\tbody: " + m.getBody());
	    
		    //Object contents = XML.objectFromXML(m.getBody());
		    //Element contentel = new Element("issue");

		    
		    String SAXDriverClass = "org.apache.xerces.parsers.SAXParser";
		    //String SAXDriverClass = "SAXParser";

		    StringReader reader = new StringReader(m.getBody());
		    SAXBuilder builder = new org.jdom.input.SAXBuilder(SAXDriverClass);
		    Document doc = builder.build(reader);
		    
		    //Document doc = XML.parseXML(m.getBody());

		    System.out.println("document= "+ doc.toString());

		    Element ixroot = doc.getRootElement();
		    System.out.println("ixroot= "+ ixroot.toString());
		    // ix xml parsing bit:
		    Element ixpattern = ixroot.getChild("pattern");
	     	    //System.out.println("child= "+ ixpattern.toString());
		    Element ixlist = ixpattern.getChild("list");
		    List ixcontent = ixlist.getChildren();
		    
		    String mcontent = "";
		    
		    while(!ixcontent.isEmpty()){
		    	mcontent += ((Element) ixcontent.get(0)).getText();
		    	ixcontent.remove(0);
			if(!ixcontent.isEmpty()) mcontent += " ";
		    }
		    
		    //mcontent = ((Element) ixcontent.get(1)).getText();
		    System.out.println("Content = "+mcontent);
    
		    

		    //contentel.setText(contents);
		    //Text contents = new Text(m.getBody());

		    // and pass on contents to mifflin agent:
		    //String mifflinissue = getIssueString(contents);
		    // can append !,?,+,- before sending to mifflin

		    String msender = m.getFromAddress().toString();	  
		    int aInd = msender.lastIndexOf("@");
		    String sname = msender.substring(0,aInd);
		    sendText("?"+mcontent+" ("+sname+")");

		}
		catch (Exception e){

		    System.out.println(e.toString());

		}

	    }

	    if(p instanceof Presence){
		try{
		    Presence pr = (Presence)p;
		    System.out.println("\nPresence: " 
				       + pr.getFromAddress().toString() 
				       + " --- " + pr.getStatus() + "\n");
		}
		catch (Exception e){
		    System.out.println(e.toString());
		}
	    }		
	}

	public void sentPacket(PacketEvent pe)
	{
	    System.out.println("PLDebug: Sent Packet : " + 
			       pe.getPacket().toString());
	}
	public void sendFailed(PacketEvent pe)
	{
	    System.out.println("PLDebug: Send Failed Packet : " + 
			       pe.getPacket().toString());
	}
    }

    static String getIssueString(Text n)
    {
	try{
	    String issue = n.toString();
	    System.out.println(issue);
	    return(issue);
	}
	catch (Exception e){
	    System.out.println(e.toString());
	}
	return("?");
    }

    public static void main(String argv[]){
	System.out.println(argv[0]);
	
	
	if(argv.length==1){
	    int resInd = argv[0].lastIndexOf("/");	
	    mifflinServer = argv[0].substring(0,resInd);
	    mifflinID = argv[0].substring(resInd+1);
	}
	else{
	    mifflinServer = "IX-stephenp@akt.aiai.ed.ac.uk";
	    mifflinID = "Winjab";
	}
        System.out.println("\nMifflin gate:"+mifflinServer
			   +" ID: "+mifflinID);
	setupServer();
    }

}
